﻿////////////////////////////
// configure app
////////////////////////////
Ha.WebApp.Configure = Ha.WebApp.Configure || {};

// local variables
Ha.WebApp.Configure.SelectedModule = null;
Ha.WebApp.Configure.SelectedModuleProperty = null;


// MySensors driver
Ha.WebApp.Configure.InitMySensorsDriver = function () {
    // enabled
    $('[id=configure_driver_mysensorsoptions]').each(function () { $(this).hide() });
    $("#configure_driver_mysensors_enabled").unbind("slidestop");
    Ha.Data.ServiceCall("Config/Driver/MySensors/GetIsEnabled/", null, "GET", function (data) {
        $('#configure_driver_mysensors_enabled').val(data).slider('refresh');
        if ($("#configure_driver_mysensors_enabled").val() != "0") {
            $('[id=configure_driver_mysensorsoptions]').each(function () { $(this).show() });
        }
        else {
            $('[id=configure_driver_mysensorsoptions]').each(function () { $(this).hide() });
        }
    });

    $("#configure_driver_mysensors_enabled").on('slidestop', function (event) {
        Ha.Data.ServiceCall("Config/Driver/MySensors/SetIsEnabled/" + $("#configure_driver_mysensors_enabled").val() + "/", null, "POST", function (data) {
            $('#configure_driver_mysensors_enabled').val(data).slider('refresh');
            if ($("#configure_driver_mysensors_enabled").val() != "0") {
                $('[id=configure_driver_mysensorsoptions]').each(function () { $(this).show() });
            }
            else {
                $('[id=configure_driver_mysensorsoptions]').each(function () { $(this).hide() });
            }
        });
    });


    // channel
    $("#configure_driver_mysensorschannel").unbind("slidestop");
    Ha.Data.ServiceCall("Config/Driver/MySensors/GetChannel/", null, "GET", function (data) {
        $("#configure_driver_mysensorschannel").val(data).slider('refresh');
    });
    $("#configure_driver_mysensorschannel").on("slidestop", function (event, ui) {
        Ha.Data.ServiceCall("Config/Driver/MySensors/SetChannel/" + $("#configure_driver_mysensorschannel").val() + "/", null, "GET", function (data) {
            $("#configure_driver_mysensorschannel").val(data).slider('refresh');
        });
    });

    // base radio id
    $("#configure_driver_mysensorsbaseradioid").unbind("change");
    Ha.Data.ServiceCall("Config/Driver/MySensors/GetBaseRadioId/", null, "GET", function (baseradioid) {
        $("#configure_driver_mysensorsbaseradioid").val(baseradioid);
    });
    $("#configure_driver_mysensorsbaseradioid").on('change', function (event) {
        Ha.Data.ServiceCall("Config/Driver/MySensors/SetBaseRadioId/" + $("#configure_driver_mysensorsbaseradioid").val(), null, "POST", function (data) {
            $('#configure_driver_mysensorsbaseradioid').val(data);
        });
    });

    // data rate
    $("#configure_driver_mysensorsdatarate").unbind("change");
    Ha.Data.ServiceCall("Config/Driver/MySensors/GetDataRate/", null, "GET", function (dataRate) {
        $("#configure_driver_mysensorsdatarate").val(dataRate);
        $('#configure_driver_mysensorsdatarate').selectmenu("refresh");
    });
    $("#configure_driver_mysensorsdatarate").on('change', function (event) {
        Ha.Data.ServiceCall("Config/Driver/MySensors/SetDataRate/" + $("#configure_driver_mysensorsdatarate").val(), null, "POST", function (data) {
            $('#configure_driver_mysensorsdatarate').val(data);
            $('#configure_driver_mysensorsdatarate').selectmenu("refresh");
        });
    });



    // PA level
    $("#configure_driver_mysensorspalevel").unbind("change");
    Ha.Data.ServiceCall("Config/Driver/MySensors/GetPowerAmplifierLevel/", null, "GET", function (dataRate) {
        $("#configure_driver_mysensorspalevel").val(dataRate);
        $('#configure_driver_mysensorspalevel').selectmenu("refresh");
    });
    $("#configure_driver_mysensorspalevel").on('change', function (event) {
        Ha.Data.ServiceCall("Config/Driver/MySensors/SetPowerAmplifierLevel/" + $("#configure_driver_mysensorspalevel").val(), null, "POST", function (data) {
            $('#configure_driver_mysensorspalevel').val(data);
            $('#configure_driver_mysensorspalevel').selectmenu("refresh");
        });
    });

    // debugmode
    $("#configure_driver_mysensors_debug").unbind("slidestop");
    Ha.Data.ServiceCall("Config/Driver/MySensors/GetDebugMode/", null, "GET", function (data) {
        $('#configure_driver_mysensors_debug').val(data).slider('refresh');
    });

    $("#configure_driver_mysensors_debug").on('slidestop', function (event) {
        Ha.Data.ServiceCall("Config/Driver/MySensors/SetDebugMode/" + $("#configure_driver_mysensors_debug").val() + "/", null, "POST", function (data) {
            $('#configure_driver_mysensors_debug').val(data).slider('refresh');
        });
    });


    $("#configure_driver_mysensorsremovenode_popup").unbind("popupbeforeposition");
    $('#configure_driver_mysensorsremovenode_popup').on('popupbeforeposition', function (event) {
        Ha.WebApp.Configure.DriverModuleListViewItems('MySensors', function (data) {
            $('#configure_driver_mysensorsremovenode').empty();
            $('#configure_driver_mysensorsremovenode').append(data);
            $('#configure_driver_mysensorsremovenode').selectmenu('refresh');
        });
    });

    $("#configure_driver_mysensorsremovenode_button").unbind("click");
    $('#configure_driver_mysensorsremovenode_button').on('click', function (event) {
        var selectedopt = $('#configure_driver_mysensorsremovenode').find(":selected");
        var domain = selectedopt.attr('data-context-domain');
        var address = selectedopt.attr('data-context-value');
        if (domain != null)
            Ha.WebApp.Configure.RemoveModule(domain, address);
    });
}




// ESP8266 EasyIoT driver
Ha.WebApp.Configure.InitEsp8266EasyIoTDriver = function () {
    // enabled
    $('[id=configure_driver_esp8266easyiotoptions]').each(function () { $(this).hide() });
    $("#configure_driver_esp8266easyiot_enabled").unbind("slidestop");
    Ha.Data.ServiceCall("Config/Driver/Esp8266/GetIsEnabled/", null, "GET", function (data) {
        $('#configure_driver_esp8266easyiot_enabled').val(data).slider('refresh');
        if ($("#configure_driver_esp8266easyiot_enabled").val() != "0") {
            $('[id=configure_driver_esp8266easyiotoptions]').each(function () { $(this).show() });
        }
        else {
            $('[id=configure_driver_esp8266easyiotoptions]').each(function () { $(this).hide() });
        }
    });

    $("#configure_driver_esp8266easyiot_enabled").on('slidestop', function (event) {
        Ha.Data.ServiceCall("Config/Driver/Esp8266/SetIsEnabled/" + $("#configure_driver_esp8266easyiot_enabled").val() + "/", null, "POST", function (data) {
            $('#configure_driver_esp8266easyiot_enabled').val(data).slider('refresh');
            if ($("#configure_driver_esp8266easyiot_enabled").val() != "0") {
                $('[id=configure_driver_esp8266easyiotoptions]').each(function () { $(this).show() });
            }
            else {
                $('[id=configure_driver_esp8266easyiotoptions]').each(function () { $(this).hide() });
            }
        });
    });


    // debugmode
    $("#configure_driver_esp8266easyiot_debug").unbind("slidestop");
    Ha.Data.ServiceCall("Config/Driver/Esp8266/GetDebugMode/", null, "GET", function (data) {
        $('#configure_driver_esp8266easyiot_debug').val(data).slider('refresh');
    });

    $("#configure_driver_esp8266easyiot_debug").on('slidestop', function (event) {
        Ha.Data.ServiceCall("Config/Driver/Esp8266/SetDebugMode/" + $("#configure_driver_esp8266easyiot_debug").val() + "/", null, "POST", function (data) {
            $('#configure_driver_esp8266easyiot_debug').val(data).slider('refresh');
        });
    });



    // HTTP port
    $("#configure_driver_esp8266easyiot_port").unbind("change");
    Ha.Data.ServiceCall("Config/Driver/Esp8266/GetPort", null, "GET", function (port) {
        $("#configure_driver_esp8266easyiot_port").val(port);
    });
    $("#configure_driver_esp8266easyiot_port").on('change', function (event) {
        Ha.Data.ServiceCall("Config/Driver/Esp8266/SetPort/" + $("#configure_driver_esp8266easyiot_port").val(), null, "POST", function (data) {
            $('#configure_driver_esp8266easyiot_port').val(data);
        });
    });



    $("#configure_driver_esp8266easyiotremovenode_popup").unbind("popupbeforeposition");
    $('#configure_driver_esp8266easyiotremovenode_popup').on('popupbeforeposition', function (event) {
        Ha.WebApp.Configure.DriverModuleListViewItems('Esp8266', function (data) {
            $('#configure_driver_esp8266easyiotremovenode').empty();
            $('#configure_driver_esp8266easyiotremovenode').append(data);
            $('#configure_driver_esp8266easyiotremovenode').selectmenu('refresh');
        });
    });

    $("#configure_driver_esp8266easyiotremovenode_button").unbind("click");
    $('#configure_driver_esp8266easyiotremovenode_button').on('click', function (event) {
        var selectedopt = $('#configure_driver_esp8266easyiotremovenode').find(":selected");
        var domain = selectedopt.attr('data-context-domain');
        var address = selectedopt.attr('data-context-value');
        if (domain != null)
            Ha.WebApp.Configure.RemoveModule(domain, address);
    });




}


// TODO dodaj unbind
Ha.WebApp.Configure.InitPage = function () {

    // Config -> Groups
    $('[data-role=popup]').on('popupbeforeposition', function (event) {
        if (this.id == 'control_group_add') {
            $('#group_new_name').val('');
        }
    });
    // bind click add group	
    $('#group_new_button').bind('click', function (event) {
        Ha.WebApp.Configure.GroupAdd($('#group_new_name').val());
    });

    // Config->groups->modules
    // update module button event
    $('#config_module_update_button').bind('click', function (event) {
        //alert('update');
        Ha.WebApp.Configure.SelectedModule.Description = $('#config_module_name').val();
        Ha.WebApp.Configure.SelectedModule.DeviceType = $('#config_module_type').val();

        Ha.Data.ServiceCall("Config/Module/SaveAll/", JSON.stringify(Ha.Data.Modules), "POST", function () {
            Ha.WebApp.Configure.ReloadModules();
        });
    });
    // remove button event
    $('#config_module_remove_button').bind('click', function (event) {
        //alert('remove');
        Ha.Data.Module.RemoveFromGroup(selectedGroupName, Ha.WebApp.Configure.SelectedModule.Domain, Ha.WebApp.Configure.SelectedModule.Address, function () {
            Ha.WebApp.Configure.ReloadModules();
        });
    });

    $('#config_group_module_properties').on('popupbeforeposition', function (event) {
        Ha.WebApp.Configure.LoadModuleParameters();
    });

    $('#config_groupmodules_groupname').change(function () {
        selectedGroupName = $("#config_groupslist").attr('selected-group-name');
        Ha.Data.ServiceCall("Config/Group/Rename/" + selectedGroupName, $('#config_groupmodules_groupname').val(), "POST", function (data) {
            $("#config_groupslist").attr('selected-group-name', $('#config_groupmodules_groupname').val());
        });
    });

    $('#groupmodules_group_delete_button').bind('click', function (event) {
        selectedGroupName = $("#config_groupslist").attr('selected-group-name');
        Ha.WebApp.Configure.GroupDelete(selectedGroupName);
    });

    $('#groupmodules_group_modulechoose').on('popupbeforeposition', function (event) {
        $('#groupmodules_group_moduleadd').empty();
        selectedGroupName = $("#config_groupslist").attr('selected-group-name');
        $('#groupmodules_group_moduleadd').append(Ha.WebApp.Configure.GroupNewModuleListViewItems(selectedGroupName));
        $('#groupmodules_group_moduleadd').selectmenu('refresh');
    });


    $('#groupmodules_group_moduleadd_button').bind('click', function (event) {
        var selectedopt = $('#groupmodules_group_moduleadd').find(":selected");
        var domain = selectedopt.attr('data-context-domain');
        var address = selectedopt.attr('data-context-value');
        selectedGroupName = $("#config_groupslist").attr('selected-group-name');
        Ha.WebApp.Configure.AddGroupModule(selectedGroupName, domain, address);
    });
}

Ha.WebApp.Configure.GetIconForDeviceType = function (deviceType) {
    var icon;
    if (deviceType == 'S_GENERIC')
        icon = "images/widgets/sensor.png";
    else if (deviceType == 'S_DIGITAL_INPUT')
        icon = "images/widgets/digital_input.png";
    else if (deviceType == 'S_DIGITAL_OUTPUT')
        icon = "images/widgets/socket_off.png";
    else if (deviceType == 'S_DOOR')
        icon = "images/widgets/door_closed.png";
//    else if (deviceType == 'S_ANALOG_INPUT')
//        icon = "images/widgets/door_closed.png";
    else if (deviceType == 'S_TEMP')
        icon = "images/widgets/temperature.png";
    else if (deviceType == 'S_HUM')
        icon = "images/widgets/humidity.png";
    else if (deviceType == 'S_LEAK')
        icon = "images/widgets/leak_ok.png";
    else
        icon = "images/widgets/sensor.png";

    return icon;
}

Ha.WebApp.Configure.RenderGroups = function () {
    $('#config_groupslist').empty();

    var el = '<li data-role="list-divider">Groups</li>';

    for (var i = 0; i < Ha.Data.Groups.length; i++) {
        group = Ha.Data.Groups[i];
        el += '<li data-group-name="' + group.GroupName + '"><a href="#page_groupmodules_groupmodules" data-transition="slide">' + group.GroupName + '<span class="ui-li-count">' + group.Modules.length + '</span></a></li>';
    }

    $('#config_groupslist').append(el);

    $("#config_groupslist li").unbind("click");
    $("#config_groupslist li").bind("click", function () {
        $("#config_groupslist").attr('selected-group-name', $(this).attr('data-group-name'));
        //$("#config_groupslist").attr('selected-group-name', $(this).text());
        //$("#configure_groupslist").attr('selected-group-index', $(this).attr('data-group-index'));
    });

    $("#config_groupslist").listview("refresh");
}

Ha.WebApp.Configure.ReloadGroups = function () {
    // 1. load groups
    Ha.Data.ServiceCall("Config/Group/List", null, "GET", function (data) {
        Ha.Data.Groups = data.Groups;
        // 2. render groups
        Ha.WebApp.Configure.RenderGroups();
    });
}

Ha.WebApp.Configure.GroupAdd = function (group) {
    Ha.Data.ServiceCall("Config/Group/Add", group, "POST", function (data) {
        Ha.WebApp.Configure.ReloadGroups();
    });
}


Ha.WebApp.Configure.GroupDelete = function (group) {
    //$.mobile.loading('show');
    Ha.Data.ServiceCall("Config/Group/Delete", group, "POST", function (data) {
        $.mobile.changePage($('#page_groupmodules_groups'), { transition: "reverse" });
        //$.mobile.loading('hide');
    });
};



//
Ha.WebApp.Configure.ModuleEdit = function (item) {
    var midx = item.attr('data-module-index');

    selectedGroupName = $("#config_groupslist").attr('selected-group-name');
    var groupModules = Ha.Data.Module.ListGroupModules(selectedGroupName);

    Ha.WebApp.Configure.SelectedModule = Ha.Data.Module.GetModuleByDomainAddress(groupModules.Modules[midx].Domain, groupModules.Modules[midx].Address);

    if (Ha.WebApp.Configure.SelectedModule != null) {
        $('#config_module_name').val(Ha.WebApp.Configure.SelectedModule.Description);
        $('#config_module_title').html(Ha.WebApp.Configure.SelectedModule.Domain + ' ' + Ha.WebApp.Configure.SelectedModule.Address + ' - Settings');
        //$('#config_module_type').val(module.DeviceType).attr('selected', true).siblings('option').removeAttr('selected');
        $('#config_module_type option:selected').removeAttr("selected");
        $('#config_module_type').val(Ha.WebApp.Configure.SelectedModule.DeviceType).attr('selected', true).siblings('option');
        Ha.WebApp.Configure.ModuleUpdateType(Ha.WebApp.Configure.SelectedModule.DeviceType);
        $('#config_module_type').selectmenu("refresh");
    }

}

Ha.WebApp.Configure.ModuleUpdateType = function (deviceType) {
    var icon = Ha.WebApp.Configure.GetIconForDeviceType(deviceType)
    $('#module_icon').attr('src', icon);
}

Ha.WebApp.Configure.GroupNewModuleListViewItems = function (groupname) {
    var groupmodules = Ha.Data.Module.ListGroupModules(groupname);
    var htmlopt = '';
    var cursect = '';
    for (m = 0; m < Ha.Data.Modules.length; m++) {
        var module = Ha.Data.Modules[m];
        var haselement = $.grep(groupmodules.Modules, function (value) {
            return (value.Domain == module.Domain && value.Address == module.Address);
        });
        if (haselement.length == 0) {
            //var propwidget = HG.WebApp.Utility.GetModulePropertyByName(module, "Widget.DisplayModule");
            //var vmparentid = HG.WebApp.Utility.GetModulePropertyByName(module, "VirtualModule.ParentId");
            // check if no explicit witdget is specified and it's not a virtual module
            //if ((propwidget != null && propwidget.Value != null && propwidget.Value == "") && (vmparentid != null && vmparentid.Value == module.Address)) continue;
            //
            if (cursect != module.Domain) {
                cursect = module.Domain;
                htmlopt += '<optgroup label="' + cursect + '"></optgroup>';
            }
            var displayname = module.Description != '' ? module.Description : module.DeviceType;
            displayname += ' (' + module.Address + ')';
            htmlopt += '<option data-context-domain="' + module.Domain + '" data-context-value="' + module.Address + '">' + displayname + '</option>';
        }
    }
    return htmlopt;
};



Ha.WebApp.Configure.ModulePropertyAdd = function (module, name, value, logtodatabase) {
    var found = false;
    for (var p = 0; p < module.Properties.length; p++) {

        if (module.Properties[p].Name == name) {
            module.Properties[p].Value = value;
            if (logtodatabase)
                module.Properties[p].LogToDatabase = 'true';
            else
                module.Properties[p].LogToDatabase = 'false';
            found = true;
            break;
        }

    }
    if (!found) {
        module.Properties.push({ Name: name, Value: value, LogToDatabase: logtodatabase });
    }
}


Ha.WebApp.Configure.ModulePropertyDelete = function (name) {
    var module = Ha.WebApp.Configure.SelectedModule;
    for (var p = 0; p < module.Properties.length; p++) {

        if (module.Properties[p].Name == name) {
            delete module.Properties[p];
            module.Properties.splice(p, 1);
        }
    }
}


Ha.WebApp.Configure.UpdateCurrentModuleParameter = function () {
    Ha.WebApp.Configure.ModulePropertyAdd(Ha.WebApp.Configure.SelectedModule, Ha.WebApp.Configure.SelectedModuleProperty.find('input[type=text]').first().val(), Ha.WebApp.Configure.SelectedModuleProperty.find('input[type=text]').last().val(), Ha.WebApp.Configure.SelectedModuleProperty.find('input[type=checkbox]').first().is(':checked'));
    //var stop = $('#config_group_module_params').children().last().offset().top - 314;
    //$('#config_group_module_params').animate({ scrollTop: '+=' + stop }, 1000);
    $('#config_group_module_params').children().last().find('input[type=text]').first().focus();
    Ha.WebApp.Configure.LoadModuleParameters();
}


Ha.WebApp.Configure.LoadModuleParameters = function () {
    $('#config_group_module_params').empty();
    Ha.WebApp.Configure.SelectedModuleProperty = null;
    //
    if (Ha.WebApp.Configure.SelectedModule != null) {
        if (Ha.WebApp.Configure.SelectedModule.Properties != null) {
            for (var p = 0; p < Ha.WebApp.Configure.SelectedModule.Properties.length; p++) {
                var item = '<li>';
                item += '        <div class="ui-grid-a">';
                item += '            <div class="ui-block-a" style="padding-right:7.5px;width:70%;"><input type="text" value="' + Ha.WebApp.Configure.SelectedModule.Properties[p].Name + '" onchange="Ha.WebApp.Configure.UpdateCurrentModuleParameter()" style="font-size:11pt" -class="ui-disabled" /></div>';
                item += '            <div class="ui-block-b" style="padding-left:7.5px;width:30%;"><input type="text" value="' + Ha.WebApp.Configure.SelectedModule.Properties[p].Value + '" onchange="Ha.WebApp.Configure.UpdateCurrentModuleParameter()" style="font-size:11pt" -class="ui-disabled" /></div>';
                item += '        </div>';

                item += '       <div class="ui-grid-solo">';
                item += '           <div class="ui-block-a"><label><input type="checkbox" ';
                if (Ha.WebApp.Configure.SelectedModule.Properties[p].LogToDatabase != 'false')
                    item += 'checked="checked"';
                item += ' onchange="Ha.WebApp.Configure.UpdateCurrentModuleParameter()"  >Log to database</label></div>';
                item += '       </div>';

                item += '   </li>';
                $('#config_group_module_params').append(item);
            }
        }
    }
    //
    $('#config_group_module_params').trigger('create');
    $('#config_group_module_params').listview().listview('refresh');
    $('#config_group_module_params input').focus(function () {
        var back = $(this).closest('div').parent().parent().parent();
        if (back.css('background') != '#E6E6FA') {
            $(this).attr('originalbackground', back.css('background'));
            back.css('background', '#E6E6FA');
            setTimeout("$('#automation_group_module_propdelete').removeClass('ui-disabled')", 500);
            //            setTimeout("$('#automation_group_module_propsave').removeClass('ui-disabled')", 500);
            Ha.WebApp.Configure.SelectedModuleProperty = back;
        }
    });

    $('#config_group_module_params input').click(function () {
        var back = $(this).closest('div').parent().parent().parent();
        //        if (back.css('background') != '#E6E6FA') {
        //            $(this).attr('originalbackground', back.css('background'));
        //            back.css('background', '#E6E6FA');
        setTimeout("$('#automation_group_module_propdelete').removeClass('ui-disabled')", 500);
        //            setTimeout("$('#automation_group_module_propsave').removeClass('ui-disabled')", 500);
        Ha.WebApp.Configure.SelectedModuleProperty = back;
        //        }
    });


    $('#config_group_module_params input').blur(function () {
        $(this).closest('div').parent().parent().parent().css('background', $(this).attr('originalbackground'));
        setTimeout("$('#automation_group_module_propdelete').addClass('ui-disabled')", 250);
        //        setTimeout("$('#automation_group_module_propsave').addClass('ui-disabled')", 250);
    });
}

Ha.WebApp.Configure.ModulePropertyAdd1 = function (name, value) {
    Ha.WebApp.Configure.ModulePropertyAdd(Ha.WebApp.Configure.SelectedModule, name, value, 'false');
    Ha.Data.ServiceCall("Config/Module/Update/", JSON.stringify(Ha.WebApp.Configure.SelectedModule), "POST", null);
    Ha.WebApp.Configure.LoadModuleParameters();
    //Ha.WebApp.Configure.UpdateCurrentModuleParameter();
}


Ha.WebApp.Configure.ModulePropertyDelete1 = function () {
    if (Ha.WebApp.Configure.SelectedModuleProperty != null) {
        Ha.WebApp.Configure.ModulePropertyDelete(Ha.WebApp.Configure.SelectedModuleProperty.find('input[type=text]').first().val());
        Ha.WebApp.Configure.SelectedModuleProperty.remove();
        Ha.WebApp.Configure.SelectedModuleProperty = null;
        Ha.Data.ServiceCall("Config/Module/Update/", JSON.stringify(Ha.WebApp.Configure.SelectedModule), "POST", null);
    }
}



Ha.WebApp.Configure.RenderModules = function (callback) {
    selectedGroupName = $("#config_groupslist").attr('selected-group-name');
    $("#config_groupmodules_groupname").val(selectedGroupName);

    var groupModules = Ha.Data.Module.ListGroupModules(selectedGroupName);

    $("#config_groupmodulelist").empty();

    var el = '<li data-role="list-divider">Modules</li>';

    for (var i = 0; i < groupModules.Modules.length; i++) {
        module = groupModules.Modules[i];
        el += '<li data-module-index="' + i + '"><a href="#config_group_module_edit" data-rel="popup" data-transition="pop">';

        el += '<img src=' + Ha.WebApp.Configure.GetIconForDeviceType(module.DeviceType) + '>';

        el += '<h2>' + module.Description + '</h2>';
        el += '<p><b>' + module.Domain + '</b> ' + module.Address + '</p></a>';

        el += '<a href="#config_group_module_properties" data-rel="popup" data-transition="pop">' + module.Address + '</a></li>';
    }

    $("#config_groupmodulelist").append(el);

    $("#config_groupmodulelist li").on("click", function () {
        Ha.WebApp.Configure.ModuleEdit($(this));
    });

    $("#config_groupmodulelist").listview("refresh");
    if (callback != null) callback();
}


Ha.WebApp.Configure.ReloadModules = function (callback) {
    // load modules
    Ha.Data.ServiceCall("Config/Module/List/", null, "GET", function (data) {
        Ha.Data.Modules = data.Modules;
        // 2. load groups
        Ha.Data.ServiceCall("Config/Group/List", null, "GET", function (data) {
            Ha.Data.Groups = data.Groups;
            // 3. render modules
            Ha.WebApp.Configure.RenderModules(callback);
        });
    });
}



Ha.WebApp.Configure.AddGroupModule = function (group, domain, address) {
    var alreadyexists = false;
    var moduleindex = -1;
    for (i = 0; i < Ha.Data.Groups.length; i++) {
        if (Ha.Data.Groups[i].GroupName == group) {
            for (c = 0; c < Ha.Data.Groups[i].Modules.length; c++) {
                if (domain == Ha.Data.Groups[i].Modules[c].Domain && address == Ha.Data.Groups[i].Modules[c].Address) {
                    alreadyexists = true;
                    break;
                }
            }
            if (!alreadyexists) {
                Ha.Data.Groups[i].Modules.push({ 'Address': address, 'Domain': domain });
                moduleindex = Ha.Data.Groups[i].length - 1;
            }
            //
            break;
        }
    }

    Ha.Data.ServiceCall("Config/Group/SaveAll", JSON.stringify(Ha.Data.Groups), "POST", function (data) {
        Ha.WebApp.Configure.ReloadModules(function () {
            Ha.WebApp.Configure.ModuleEdit($("#config_groupmodulelist li").last());
            //$.mobile.loading('show');
            //$('#config_group_module_edit').popup('open', { transition: 'pop' });
            setTimeout("$('#config_group_module_edit').popup('open', { transition: 'pop' });", 1000);
        });
    });
};



//Ha.WebApp.Configure.NRF24LNodeAdd = function () {
//    $('#configure_driver_nrf24laddnode_popup').popup('open');
//    $('#configure_driver_nrf24l_nodeid').html('');
//    $('#configure_driver_nrf24l_message').html('this operation will timeout in 15 seconds.');

//    Ha.Data.ServiceCall("Config/Driver/NRF24L/AddNode/", null, "POST", function (data) {
//        if (data != 0) {
//            $('#configure_driver_nrf24l_nodeid').html(data);
//            $('#configure_driver_nrf24l_message').html('node added.');
//        }
//        else {
//            $('#configure_driver_nrf24l_nodeid').html('<span style="color:red">timed out</span>');
//            $('#configure_driver_nrf24l_message').html('operation falied.');
//        }
//        $('#configure_driver_nrf24l_close_button').removeClass('ui-disabled');
//    });
//};


//Ha.WebApp.Configure.NRF24LNodeRemovePopup = function () {
//    $('#configure_driver_nrf24lremovenode_popup').popup('open');
//};



Ha.WebApp.Configure.MySensorsNodeAdd = function () {
    $('#configure_driver_mysensorsaddnode_popup').popup('open');
    $('#configure_driver_mysensors_nodeid').html('');
    $('#configure_driver_mysensors_message').html('This operation will timeout in 30 seconds.');
    $('#configure_driver_mysensors_close_button').addClass('ui-disabled');

    Ha.Data.ServiceCall("Config/Driver/MySensors/AddNode/", null, "POST", function (data) {
        if (data != 0) {
            $('#configure_driver_mysensors_nodeid').html(data);
            $('#configure_driver_mysensors_message').html('node added.');
        }
        else {
            $('#configure_driver_mysensors_nodeid').html('<span style="color:red">timed out</span>');
            $('#configure_driver_mysensors_message').html('Operation falied.');
        }
        $('#configure_driver_mysensors_instructions').html('');        
        $('#configure_driver_mysensors_close_button').removeClass('ui-disabled');
    });
};


Ha.WebApp.Configure.MySensorsNodeRemovePopup = function () {
    $('#configure_driver_mysensorsremovenode_popup').popup('open');
};



Ha.WebApp.Configure.RemoveModule = function (domain, module) {
    Ha.Data.ServiceCall("Config/Driver/" + domain + "/RemoveModule/" + module + "/", null, "POST", function (data) {
    });
};


Ha.WebApp.Configure.DriverModuleListViewItems = function (domain, callback) {
    var htmlopt = '';
    Ha.Data.ServiceCall("Config/Module/List/", null, "GET", function (data) {
        Ha.Data.Modules = data.Modules;
        for (m = 0; m < Ha.Data.Modules.length; m++) {
            var module = Ha.Data.Modules[m];
            if (module.Domain == domain) {
                var displayname = module.Description != '' ? module.Description : module.DeviceType;
                displayname += ' (' + module.Address + ')';
                htmlopt += '<option data-context-domain="' + module.Domain + '" data-context-value="' + module.Address + '">' + displayname + '</option>';
            }
        }
        if (callback != null) callback(htmlopt);
    });
};



Ha.WebApp.Configure.InitWebinterface = function () {
    // HTTP port
    $("#configure_webinterface_http_port").unbind("change");
    Ha.Data.ServiceCall("Config/Webinterface/GetHttpPort", null, "GET", function (port) {
        $("#configure_webinterface_http_port").val(port);
    });
    $("#configure_webinterface_http_port").on('change', function (event) {
        Ha.Data.ServiceCall("Config/Webinterface/SetHttpPort/" + $("#configure_webinterface_http_port").val(), null, "POST", function (data) {
            $('#configure_webinterface_http_port').val(data);
        });
    });

    // SSL port
    $("#configure_webinterface_ssl_port").unbind("change");
    Ha.Data.ServiceCall("Config/Webinterface/GetSslPort", null, "GET", function (port) {
        $("#configure_webinterface_ssl_port").val(port);
    });
    $("#configure_webinterface_ssl_port").on('change', function (event) {
        Ha.Data.ServiceCall("Config/Webinterface/SetSslPort/" + $("#configure_webinterface_ssl_port").val(), null, "POST", function (data) {
            $('#configure_webinterface_ssl_port').val(data);
        });
    });

    // force SSL
    $("#configure_webinterface_forcessl").unbind("slidestop");
    Ha.Data.ServiceCall("Config/Webinterface/GetForceSsl", null, "GET", function (data) {
        $('#configure_webinterface_forcessl').val(data).slider('refresh');
        //$('#configure_webinterface_forcessl').slider('refresh');
    });
    $("#configure_webinterface_forcessl").on('slidestop', function (event) {
        Ha.Data.ServiceCall("Config/Webinterface/SetForceSsl/" + $("#configure_webinterface_forcessl").val(), null, "POST", function (data) {
            $('#configure_webinterface_forcessl').val(data).slider('refresh');
        });
    });

    //add new user 
    $("#add_user_button").unbind("click");
    $('#add_user_button').on('click', function (event) {
        Ha.Data.ServiceCall("Config/Webinterface/AddUser/" + $("#add_user_name").val(), $("#add_user_password").val(), "POST", function (data) {
            if (data == '1') {
                $("#add_user_name").val("");
                $("#add_user_password").val("");
            }
            else {
                alert("Error ading new user. The user " + $("#add_user_name").val() + " already exist!");
            }
        });
    })

    // remove user
    $("#user_remove_popup").unbind("popupbeforeposition");
    $('#user_remove_popup').on('popupbeforeposition', function (event) {
        Ha.WebApp.Configure.WebinterfaceRemoveUserViewItems(function (data) {
            $('#user_remove').empty();
            $('#user_remove').append(data);
            $('#user_remove').selectmenu('refresh');
        });
    });

}


Ha.WebApp.Configure.WebinterfaceRemoveUserViewItems = function (callback) {
    var htmlopt = '';
    Ha.Data.ServiceCall("Config/Webinterface/UserList/", null, "GET", function (data) {
        users = data;
        for (m = 0; m < users.length; m++) {
            var u = users[m];
            if (u.Username == 'admin')
                continue;
            htmlopt += '<option data-context-value="' + u.Username + '">' + u.Username + '</option>';
        }
        if (callback != null) callback(htmlopt);
    });
};


$("#user_remove_button").unbind("click");
$('#user_remove_button').on('click', function (event) {
    var selectedopt = $('#user_remove').find(":selected");
    var username = selectedopt.attr('data-context-value');
    Ha.Data.ServiceCall("Config/Webinterface/RemoveUser/" + username, null, "POST", null);
});





///////////////////////// AUTOMATION
Ha.WebApp.Configure.AutomationRenderGroups = function () {
    $('#config_automation_groupslist').empty();

    var el = '<li data-role="list-divider">Automation groups</li>';

    for (var i = 0; i < Ha.Data.AutomationGroups.length; i++) {
        group = Ha.Data.AutomationGroups[i];
        el += '<li data-group-name="' + group.GroupName + '"><a href="#page_automation_automationlist" data-transition="slide">' + group.GroupName + '<span class="ui-li-count">' + group.Programs.length + '</span></a></li>';
    }

    $('#config_automation_groupslist').append(el);

    $("#config_automation_groupslist li").bind("click", function () {
        $("#config_automation_groupslist").attr('selected-group-name', $(this).attr('data-group-name'));
    });

    $("#config_automation_groupslist").listview("refresh");
}

Ha.WebApp.Configure.AutomationReloadGroups = function () {
    // 1. load groups
    Ha.Data.ServiceCall("Config/AutomationGroup/List", null, "GET", function (data) {
        Ha.Data.AutomationGroups = data;
        // 2. render groups
        Ha.WebApp.Configure.AutomationRenderGroups();
    });
}

Ha.WebApp.Configure.InitAutomationGroups = function () {
    Ha.WebApp.Configure.AutomationReloadGroups();

    // bind click add group	
    $("#group_automation_new_button").unbind("click");
    $('#group_automation_new_button').bind('click', function (event) {
        Ha.WebApp.Configure.AutomationGroupAdd($('#group_automation_new_name').val());
    });

}

Ha.WebApp.Configure.AutomationGroupAdd = function (group) {
    Ha.Data.ServiceCall("Config/AutomationGroup/Add", group, "POST", function (data) {
        Ha.WebApp.Configure.AutomationReloadGroups();
        $('#group_automation_new_name').val('');
    });
}

Ha.WebApp.Configure.RenderAutomationList = function (callback) {
    selectedGroupName = $("#config_automation_groupslist").attr('selected-group-name');
    $("#config_automation_automationlistname").val(selectedGroupName);

    $("#config_automation_automationlist").empty();

    var el = '<li data-role="list-divider">Program list</li>';


    for (var j = 0; j < Ha.Data.AutomationGroups.length; j++) {
        var automationGroup = Ha.Data.AutomationGroups[j];

        if (automationGroup.GroupName == selectedGroupName) {
            for (var i = 0; i < automationGroup.Programs.length; i++) {
                var program = automationGroup.Programs[i];
                el += '<li data-program-id="' + program.ProgramId + '" data-icon="' + (program.Enabled ? 'check' : 'forward') + '">';

                el += '<a href="#page_automation_automationprogramparam" data-transition="slide">';

                //el += '<img src=' + Ha.WebApp.Configure.GetIconForDeviceType(module.DeviceType) + '>';

                el += '<h2>' + program.Name + '</h2>';

                el += '<p><b>Cron:</b> ' + program.CronExpression + '</p>';
                el += '<p class="ui-li-aside"><strong>4:48</strong>PM</p>';
                el += '</a>';

                el += '<a href="javascript:Ha.WebApp.Configure.AutomationProgramToggleEnabled(\'' + program.ProgramId + '\')" >';

                el += (program.Enabled ? 'Tap to DISABLE program' : 'Tap to ENABLE program');

                el += '</a>';
                //el += '<p><b>' + module.Domain + '</b> ' + module.Address + '</p></a>';

                el += '</li>';
            }
        }
    }

    $("#config_automation_automationlist").append(el);

    //    $("#config_automation_automationlist li").on("click", function () {
    //        Ha.WebApp.Configure.ModuleEdit($(this));
    //    });

    $("#config_automation_automationlist").listview("refresh");

    $("#config_automation_automationlist li").unbind("click");
    $("#config_automation_automationlist li").bind("click", function () {
        $("#config_automation_automationlist").attr('data-program-id', $(this).attr('data-program-id'));
    });

    if (callback != null) callback();
}


Ha.WebApp.Configure.ReloadAutomationList = function (callback) {
    // 1. load groups
    Ha.Data.ServiceCall("Config/AutomationGroup/List", null, "GET", function (data) {
        Ha.Data.AutomationGroups = data;
        // 3. render modules
        Ha.WebApp.Configure.RenderAutomationList(callback);
    });
}


Ha.WebApp.Configure.GetProgramById = function (programId) {
    for (var j = 0; j < Ha.Data.AutomationGroups.length; j++) {
        var automationGroup = Ha.Data.AutomationGroups[j];
        for (var i = 0; i < automationGroup.Programs.length; i++) {
            var program = automationGroup.Programs[i];
            if (program.ProgramId == programId)
                return program;
        }

    }
    return null;
}

Ha.WebApp.Configure.AutomationProgramToggleEnabled = function (pid) {
    var program = Ha.WebApp.Configure.GetProgramById(pid);
    program.Enabled = !program.Enabled;

    var val = 0;
    if (program.Enabled)
        val = 1;

    Ha.Data.ServiceCall("Config/AutomationProgram/" + pid + "/SetEnabled/" + val, null, "POST", function (data) {
        Ha.WebApp.Configure.ReloadAutomationList();
    });
}

Ha.WebApp.Configure.InitAutomationList = function () {
    $("#config_automation_automationlistname").unbind("change");
    $('#config_automation_automationlistname').change(function () {
        selectedGroupName = $("#config_automation_groupslist").attr('selected-group-name');
        Ha.Data.ServiceCall("Config/AutomationGroup/Rename/" + selectedGroupName, $('#config_automation_automationlistname').val(), "POST", function (data) {
            $("#config_automation_groupslist").attr('selected-group-name', $('#config_automation_automationlistname').val());
        });
    });

    $("#automationlist_automationgroup_delete_button").unbind("click");
    $('#automationlist_automationgroup_delete_button').bind('click', function (event) {
        selectedGroupName = $("#config_automation_groupslist").attr('selected-group-name');
        Ha.Data.ServiceCall("Config/AutomationGroup/Delete/" + selectedGroupName, null, "POST", function (data) {
            $.mobile.changePage($('#page_automation_automationgroups'), { transition: "reverse" });
        });
    });

    $("#automationlist_automationgroup_addprogram_button").unbind("click");
    $('#automationlist_automationgroup_addprogram_button').bind('click', function (event) {
        selectedGroupName = $("#config_automation_groupslist").attr('selected-group-name');

        var data1 = {
            Name: '',
            CronExpression: ''
        };

        data1.Name = $("#automationlist_automationgroup_addprogram_programname").val();
        data1.CronExpression = $("#automationlist_automationgroup_addprogram_cron").val();

        Ha.Data.ServiceCall("Config/AutomationGroup/AddProgram/" + selectedGroupName, JSON.stringify(data1), "POST", function (data) {
            Ha.WebApp.Configure.ReloadAutomationList(function (event) {
                $("#automationlist_automationgroup_addprogram_programname").val('');
                $("#automationlist_automationgroup_addprogram_cron").val('');

                var pid = $("#config_automation_automationlist li").last().attr('data-program-id');
                $("#config_automation_automationlist").attr('data-program-id', pid);

                $.mobile.changePage($('#page_automation_automationprogramparam'), { transition: "slide" });

            });
        });
    });


    Ha.WebApp.Configure.ReloadAutomationList();
}



Ha.WebApp.Configure.InitProgramParam = function () {
    var pid = $("#config_automation_automationlist").attr('data-program-id');
    Ha.Data.ServiceCall("Config/AutomationProgram/" + pid + "/List/", null, "GET", function (data) {
        Ha.Data.AutomationProgram = data;

        $("#config_automation_param_programname").val(Ha.Data.AutomationProgram.Name);
        $("#config_automation_param_cron").val(Ha.Data.AutomationProgram.CronExpression);
        $("#config_automation_param_enabled").unbind("slidestop")
        if (Ha.Data.AutomationProgram.Enabled)
            $('#config_automation_param_enabled').val(1).slider('refresh');
        else
            $('#config_automation_param_enabled').val(0).slider('refresh');

        $("#config_automation_param_enabled").on('slidestop', function (event) {
            Ha.Data.ServiceCall("Config/AutomationProgram/" + pid + "/SetEnabled/" + $("#config_automation_param_enabled").val(), null, "POST", function (data) {
                $('#config_automation_param_enabled').val(data).slider('refresh');
            });
        });

    });

    //
    $("#config_automation_param_programname").unbind("change");
    $('#config_automation_param_programname').change(function () {
        Ha.Data.ServiceCall("Config/AutomationProgram/" + Ha.Data.AutomationProgram.ProgramId + "/Rename/" + $('#config_automation_param_programname').val(), null, "POST", function (data) {
            $("#config_automation_automationlist").attr('data-program-id', $('#config_automation_param_programname').val());
        });
    });

    $("#config_automation_param_cron").unbind("change");
    $('#config_automation_param_cron').change(function () {
        Ha.Data.ServiceCall("Config/AutomationProgram/" + Ha.Data.AutomationProgram.ProgramId + "/SetCron/" + $('#config_automation_param_cron').val(), null, "POST", function (data) {
        });
    });

    $("#page_automation_automationprogram_delete_button").unbind("click");
    $('#page_automation_automationprogram_delete_button').bind('click', function (event) {
        Ha.Data.ServiceCall("Config/AutomationProgram/" + Ha.Data.AutomationProgram.ProgramId + "/Delete/", null, "POST", function (data) {
            $.mobile.changePage($('#page_automation_automationlist'), { transition: "reverse" });
        });
    });
}

Ha.WebApp.Configure.csharpEditor = null;

Ha.WebApp.Configure.InitProgram = function () {

    var pid = $("#config_automation_automationlist").attr('data-program-id');
    Ha.Data.ServiceCall("Config/AutomationProgram/" + pid + "/List/", null, "GET", function (data) {
        Ha.Data.AutomationProgram = data;


        if (Ha.WebApp.Configure.csharpEditor != null) {
            Ha.WebApp.Configure.csharpEditor.setValue(Ha.Data.AutomationProgram.SourceCode);
        }
        else {
            $('#automation_program_script').val(Ha.Data.AutomationProgram.SourceCode);

            Ha.WebApp.Configure.csharpEditor = CodeMirror.fromTextArea(document.getElementById("automation_program_script"), {
                parserfile: ["/js/codemirror-4.5/tokenizecsharp.js", "/js/codemirror-4.5/parsecsharp.js"],
                stylesheet: "/css/codemirror-4.5/csharpcolors.css",
                path: "/js/codemirror-4.5/",
                lineNumbers: true,
                matchBrackets: true,
                mode: "text/x-csharp"
            });
        }
    });
}


Ha.WebApp.Configure.AutomationProgramUpdate = function () {

    if (Ha.WebApp.Configure.csharpEditor != null)
        Ha.Data.AutomationProgram.SourceCode = Ha.WebApp.Configure.csharpEditor.getValue();
    //Ha.Data.AutomationProgram.SourceCode = $("#automation_program_script").val();

    var pid = $("#config_automation_automationlist").attr('data-program-id');

    Ha.Data.ServiceCall("Config/AutomationProgram/" + pid + "/Update/", JSON.stringify(Ha.Data.AutomationProgram), "POST", function (message) {

        if (message.length != 0) {
            msg = '';
            for (var i = 0; i < message.length; i++) {
                err = message[i];
                msg += "Error " + err.ErrorNumber + " in line " + err.Line + " column " + err.Column + ", " + err.ErrorMessage + "<br>";
            }
            $('#program_error_message_text').html('<h3>Errors:</h3><i>' + msg + '</i><h3 style="color:red;font-weight:bold">Program disabled, fix errors first.</h3>');
            $('#program_error_message').popup().popup('open');
        }
    });
}



Ha.WebApp.Configure.InitGeneralSettings = function () {
}



Ha.WebApp.Configure.InitSmsinterface = function () {
    // enbled
    $("#configure_smsinterface_enabled").unbind("slidestop");
    Ha.Data.ServiceCall("Config/Smsinterface/GetEnabled", null, "GET", function (data) {
        $('#configure_smsinterface_enabled').val(data).slider('refresh');
    });
    $("#configure_smsinterface_enabled").on('slidestop', function (event) {
        Ha.Data.ServiceCall("Config/Smsinterface/SetEnabled/" + $("#configure_smsinterface_enabled").val(), null, "POST", function (data) {
            $('#configure_smsinterface_enabled').val(data).slider('refresh');
        });
    });

    // port
    $("#configure_smsinterface_port").unbind("change");
    Ha.Data.ServiceCall("Config/Smsinterface/GetPort", null, "GET", function (port) {
        $("#configure_smsinterface_port").val(port);
    });
    $("#configure_smsinterface_port").on('change', function (event) {
        Ha.Data.ServiceCall("Config/Smsinterface/SetPort/" + $("#configure_smsinterface_port").val(), null, "POST", function (data) {
            $('#configure_smsinterface_port').val(data);
        });
    });

    // alowed sender
    $("#configure_smsinterface_alowed_sender").unbind("change");
    Ha.Data.ServiceCall("Config/Smsinterface/GetAlowedSender", null, "GET", function (port) {
        $("#configure_smsinterface_alowed_sender").val(port);
    });
    $("#configure_smsinterface_alowed_sender").on('change', function (event) {
        Ha.Data.ServiceCall("Config/Smsinterface/SetAlowedSender/" + $("#configure_smsinterface_alowed_sender").val(), null, "POST", function (data) {
            $('#configure_smsinterface_alowed_sender').val(data);
        });
    });


    // debug 
    $("#configure_smsinterface_debug").unbind("slidestop");
    Ha.Data.ServiceCall("Config/Smsinterface/GetDebugMode", null, "GET", function (data) {
        $('#configure_smsinterface_debug').val(data).slider('refresh');
    });
    $("#configure_smsinterface_debug").on('slidestop', function (event) {
        Ha.Data.ServiceCall("Config/Smsinterface/SetDebugMode/" + $("#configure_smsinterface_debug").val(), null, "POST", function (data) {
            $('#configure_smsinterface_debug').val(data).slider('refresh');
        });
    });


    //add sms shotcut
    $("#add_sms_shortcut").unbind("click");
    $('#add_sms_shortcut').on('click', function (event) {
        Ha.Data.ServiceCall("Config/Smsinterface/Add/" + $("#sms_shortcut").val(), $("#sms_comamnd").val(), "POST", function (data) {
            if (data == '1') {
                $("#sms_shortcut").val("");
                $("#sms_comamnd").val("");
            }
            else {
                alert("Error ading new user. The shortcut " + $("#sms_shortcut").val() + " already exist!");
            }
        });
    })

    // remove user
    $("#sms_shotcut_remove_popup").unbind("popupbeforeposition");
    $('#sms_shotcut_remove_popup').on('popupbeforeposition', function (event) {
        Ha.WebApp.Configure.SmsinterfaceRemoveShortcutViewItems(function (data) {
            $('#sms_shortcut_remove').empty();
            $('#sms_shortcut_remove').append(data);
            $('#sms_shortcut_remove').selectmenu('refresh');
        });
    });



    $("#sms_shortcut_button").unbind("click");
    $('#sms_shortcut_button').on('click', function (event) {
        var selectedopt = $('#sms_shortcut_remove').find(":selected");
        var shortcut = selectedopt.attr('data-context-value');
        Ha.Data.ServiceCall("Config/Smsinterface/Remove/" + shortcut, null, "POST", null);
    });
}

Ha.WebApp.Configure.SmsinterfaceRemoveShortcutViewItems = function (callback) {
    var htmlopt = '';
    Ha.Data.ServiceCall("Config/Smsinterface/List/", null, "GET", function (data) {
        users = data;
        for (m = 0; m < users.length; m++) {
            var u = users[m];
            htmlopt += '<option data-context-value="' + u.Shortcut + '">' + u.Shortcut + ' => ' + u.Command + '</option>';
        }
        if (callback != null) callback(htmlopt);
    });
};

Ha.WebApp.Configure.UpdateResistor = function (connectorPin, gpioResistor) {
    var resistor = 'configure_gpio_' + connectorPin + '_resistor';

    if (gpioResistor == "0") {
        $('#' + resistor + '_off').prop('checked', true);
        $('#' + resistor + '_pull_up').prop('checked', false);
        $('#' + resistor + '_pull_down').prop('checked', false);
    }
    else if (gpioResistor == "2") {
        $('#' + resistor + '_off').prop('checked', false);
        $('#' + resistor + '_pull_up').prop('checked', true);
        $('#' + resistor + '_pull_down').prop('checked', false);
    }
    else if (gpioResistor == "1") {
        $('#' + resistor + '_off').prop('checked', false);
        $('#' + resistor + '_pull_up').prop('checked', false);
        $('#' + resistor + '_pull_down').prop('checked', true);
    }

    $('input:radio[name=' + resistor + ']').checkboxradio('refresh');

}

Ha.WebApp.Configure.UpdateDirection = function (connectorPin, isOutput) {
    var direction = 'configure_gpio_' + connectorPin + '_direction';
    var resistorGroup = "configure_gpio_" + connectorPin + "_resistor_group";
    
    var resistor = 'configure_gpio_' + connectorPin + '_resistor';


    if (isOutput == "0") {
        $('#' + direction + '_input').prop('checked', true);
        $('#' + direction + '_output').prop('checked', false);
        $('[id=' + resistorGroup + ']').each(function () { $(this).show() });

        $('input:radio[name=' + resistor + ']').unbind("click");
        Ha.Data.ServiceCall("Config/Driver/RPiGPIO/GetPinProperty/" + connectorPin + "/GPIOResistor/", null, "GET", function (data) {
            Ha.WebApp.Configure.UpdateResistor(connectorPin, data);
        });
        $('input:radio[name=' + resistor + ']').on('click', function () {
            Ha.Data.ServiceCall("Config/Driver/RPiGPIO/SetPinProperty/" + connectorPin + "/GPIOResistor/" + $('input[name=' + resistor + ']:checked').val(), null, "POST", function (data) {
                Ha.WebApp.Configure.UpdateResistor(connectorPin, data);
            });
        });
    }
    else {
        $('#' + direction + '_input').prop('checked', false);
        $('#' + direction + '_output').prop('checked', true);
        $('[id=' + resistorGroup + ']').each(function () { $(this).hide() });
    }
    $('input:radio[name=' + direction + ']').checkboxradio('refresh');
}

Ha.WebApp.Configure.UpdateEnabled = function (connectorPin, enabled) {
    var enabledGroup = "configure_gpio_" + connectorPin + "_enabled_group";
    var enableControl = "#configure_driver_rpigpio_" + connectorPin + "_enable";
    var direction = 'configure_gpio_' + connectorPin + '_direction';

    $(enableControl).val(enabled).slider('refresh');
    if ($(enableControl).val() != "0") {
        $('[id=' + enabledGroup + ']').each(function () { $(this).show() });

        $('input:radio[name=' + direction + ']').unbind("click");
        Ha.Data.ServiceCall("Config/Driver/RPiGPIO/GetPinProperty/" + connectorPin + "/IsOutput/", null, "GET", function (data) {
            Ha.WebApp.Configure.UpdateDirection(connectorPin, data);
        });
        $('input:radio[name=' + direction + ']').on('click', function () {
            Ha.Data.ServiceCall("Config/Driver/RPiGPIO/SetPinProperty/" + connectorPin + "/IsOutput/" + $('input[name=' + direction + ']:checked').val(), null, "POST", function (data) {
                Ha.WebApp.Configure.UpdateDirection(connectorPin, data);
            });
        });
    }
    else
        $('[id=' + enabledGroup + ']').each(function () { $(this).hide() });

}

Ha.WebApp.Configure.InitRPiGPIOPin = function (connectorPin) {
    var enableControl = "#configure_driver_rpigpio_" + connectorPin + "_enable";
    var enabledGroup = "configure_gpio_" + connectorPin + "_enabled_group";
    var direction = 'configure_gpio_' + connectorPin + '_direction';

    $(enableControl).unbind("slidestop");
    Ha.Data.ServiceCall("Config/Driver/RPiGPIO/GetPinProperty/" + connectorPin + "/Enabled/", null, "GET", function (data) {
        Ha.WebApp.Configure.UpdateEnabled(connectorPin, data);
    });

    $(enableControl).on('slidestop', function (event) {
        Ha.Data.ServiceCall("Config/Driver/RPiGPIO/SetPinProperty/" + connectorPin + "/Enabled/" + $(enableControl).val() + "/", null, "POST", function (data) {
            Ha.WebApp.Configure.UpdateEnabled(connectorPin, data);
        });
    });
}

Ha.WebApp.Configure.InitRPiGPIOPins = function (revision) {

    // rev 1, rev2, B+
    Ha.WebApp.Configure.InitRPiGPIOPin("Pin_P1_03");
    Ha.WebApp.Configure.InitRPiGPIOPin("Pin_P1_05");
    Ha.WebApp.Configure.InitRPiGPIOPin("Pin_P1_07");
    Ha.WebApp.Configure.InitRPiGPIOPin("Pin_P1_08");
    Ha.WebApp.Configure.InitRPiGPIOPin("Pin_P1_10");
    Ha.WebApp.Configure.InitRPiGPIOPin("Pin_P1_11");
    Ha.WebApp.Configure.InitRPiGPIOPin("Pin_P1_12");
    Ha.WebApp.Configure.InitRPiGPIOPin("Pin_P1_13");
    Ha.WebApp.Configure.InitRPiGPIOPin("Pin_P1_15");
    Ha.WebApp.Configure.InitRPiGPIOPin("Pin_P1_16");
    Ha.WebApp.Configure.InitRPiGPIOPin("Pin_P1_18");
    Ha.WebApp.Configure.InitRPiGPIOPin("Pin_P1_19");
    Ha.WebApp.Configure.InitRPiGPIOPin("Pin_P1_21");
    Ha.WebApp.Configure.InitRPiGPIOPin("Pin_P1_22");
    Ha.WebApp.Configure.InitRPiGPIOPin("Pin_P1_23");
    Ha.WebApp.Configure.InitRPiGPIOPin("Pin_P1_24");
    Ha.WebApp.Configure.InitRPiGPIOPin("Pin_P1_26");


    if (revision == '0') {
        $('[id=gpio_pin_group2]').each(function () { $(this).hide() });
        $('[id=gpio_pin_group3]').each(function () { $(this).hide() });
    }
    if (revision == '1') {
        $('[id=gpio_pin_group2]').each(function () { $(this).show() });
        $('[id=gpio_pin_group3]').each(function () { $(this).hide() });
        // rev 2
        Ha.WebApp.Configure.InitRPiGPIOPin("Pin_P5_03");
        Ha.WebApp.Configure.InitRPiGPIOPin("Pin_P5_04");
        Ha.WebApp.Configure.InitRPiGPIOPin("Pin_P5_05");
        Ha.WebApp.Configure.InitRPiGPIOPin("Pin_P5_06");
    }
    else if (revision == '2') {
        $('[id=gpio_pin_group2]').each(function () { $(this).hide() });
        $('[id=gpio_pin_group3]').each(function () { $(this).show() });
        //b+
        Ha.WebApp.Configure.InitRPiGPIOPin("Pin_P1_29");
        Ha.WebApp.Configure.InitRPiGPIOPin("Pin_P1_31");
        Ha.WebApp.Configure.InitRPiGPIOPin("Pin_P1_32");
        Ha.WebApp.Configure.InitRPiGPIOPin("Pin_P1_33");
        Ha.WebApp.Configure.InitRPiGPIOPin("Pin_P1_35");
        Ha.WebApp.Configure.InitRPiGPIOPin("Pin_P1_36");
        Ha.WebApp.Configure.InitRPiGPIOPin("Pin_P1_37");
        Ha.WebApp.Configure.InitRPiGPIOPin("Pin_P1_40");
    }
}

Ha.WebApp.Configure.InitRPiGPIOEnabled = function (enabled) {

    $('#configure_driver_rpigpio_enabled').val(enabled).slider('refresh');
    if ($("#configure_driver_rpigpio_enabled").val() != "0") {
        $('[id=configure_driver_rpigpiooptions]').each(function () { $(this).show() });

        // debugmode
        $("#configure_driver_rpigpio_debug").unbind("slidestop");
        Ha.Data.ServiceCall("Config/Driver/RPiGPIO/GetDebugMode/", null, "GET", function (data) {
            $('#configure_driver_rpigpio_debug').val(data).slider('refresh');
        });

        $("#configure_driver_rpigpio_debug").on('slidestop', function (event) {
            Ha.Data.ServiceCall("Config/Driver/RPiGPIO/SetDebugMode/" + $("#configure_driver_rpigpio_debug").val() + "/", null, "POST", function (data) {
                $('#configure_driver_rpigpio_debug').val(data).slider('refresh');
            });
        });


        // RPI revision
        $("#configure_driver_rpigpio_revision").unbind("change");
        Ha.Data.ServiceCall("Config/Driver/RPiGPIO/GetRevision/", null, "GET", function (revision) {
            $("#configure_driver_rpigpio_revision").val(revision);
            $('#configure_driver_rpigpio_revision').selectmenu("refresh");
            Ha.WebApp.Configure.InitRPiGPIOPins(revision);
        });
        $("#configure_driver_rpigpio_revision").on('change', function (event) {
            Ha.Data.ServiceCall("Config/Driver/RPiGPIO/SetRevision/" + $("#configure_driver_rpigpio_revision").val(), null, "POST", function (revision) {
                $('#configure_driver_rpigpio_revision').val(revision);
                $('#configure_driver_rpigpio_revision').selectmenu("refresh");
                Ha.WebApp.Configure.InitRPiGPIOPins(revision);
            });
        });
    }
    else {
        $('[id=configure_driver_rpigpiooptions]').each(function () { $(this).hide() });
    }


}


Ha.WebApp.Configure.InitRPiGPIODriver = function () {

    // enabled
    //$('[id=configure_driver_mysensorsoptions]').each(function () { $(this).hide() });
    $("#configure_driver_rpigpio_enabled").unbind("slidestop");
    Ha.Data.ServiceCall("Config/Driver/RPiGPIO/GetIsEnabled/", null, "GET", function (data) {
        Ha.WebApp.Configure.InitRPiGPIOEnabled(data);
    });


    $("#configure_driver_rpigpio_enabled").on('slidestop', function (event) {
        Ha.Data.ServiceCall("Config/Driver/RPiGPIO/SetIsEnabled/" + $("#configure_driver_rpigpio_enabled").val() + "/", null, "POST", function (data) {
            Ha.WebApp.Configure.InitRPiGPIOEnabled(data);
        });
    });
}


Ha.WebApp.Configure.Esp8266EasyIoTNodeAdd = function () {
    $('#configure_driver_esp8266easyiotaddnode_popup').popup('open');
    $('#configure_driver_esp8266easyiot_nodeid').html('');
    $('#configure_driver_esp8266easyiot_message').html('This operation will timeout in 15 seconds.');
    $('#configure_driver_esp8266easyiot_close_button').addClass('ui-disabled');

    Ha.Data.ServiceCall("Config/Driver/Esp8266/AddNode/", null, "POST", function (data) {
        if (data != 0) {
            $('#configure_driver_esp8266easyiot_nodeid').html(data);
            $('#configure_driver_esp8266easyiot_message').html('node added.');
        }
        else {
            $('#configure_driver_esp8266easyiot_nodeid').html('<span style="color:red">timed out</span>');
            $('#configure_driver_esp8266easyiot_message').html('Operation falied.');
        }
        $('#configure_driver_esp8266easyiot_instructions').html('');
        $('#configure_driver_esp8266easyiot_close_button').removeClass('ui-disabled');
    });
};


Ha.WebApp.Configure.Esp8266EasyIoTNodeRemovePopup = function () {
    $('#configure_driver_esp8266easyiotremovenode_popup').popup('open');
};
